import es, popuplib, langlib
from xa import xa
Version = '0.9.1'
main = xa.register('zombiemenu')
text = None
def load():
	global text
	#text = langlib.Strings(es.getAddonPath('xa') + '/modules/zombiemenu/strings.ini')
	text = main.language.getLanguage()
	ServerVars = {  'Zombie_Mod': 		[0, 'Do you have a custom zombie mod loaded? 0/1'],
					'Zombie_Health': 	[500,'The amount of health zombies have'],
					'Zombie_Speed': 	[0.9, 'How quick zombies move']}
	for x in ServerVars:
		main.setting.createVariable(x, ServerVars[x][0], ServerVars[x][1])
	es.server.queuecmd('exec xa/zombiemenu/zombiemenu.cfg')
	global zmenu 
	zmenu = popuplib.create('zmenu')
	zmenu.addline('- XA Zombie Menu -')
	zmenu.addline('-> 1. Raise Zombie')
	zmenu.addline('-> 2. Spawn Player')
	zmenu.addline('-> 3. Mass Zombies')
	zmenu.addline('-> 4. Mass Respawn')
	zmenu.addline('-> 9. To Main Menu')
	zmenu.addline('0. - Exit')
	zmenu.menuselect = sendPlayerMenu
	main.addMenu('zmenu', text['Zombie Menu'], 'zmenu', 'raise_player', '#admin')
def unload():
	xa.unregister('zombiemenu')
def sendPlayerMenu(userid, choice, popupid):
	if choice == 9:
		xa.sendMenu(userid)
	elif choice == 4:
		for id in es.getUseridList():
			if int(es.getplayerprop(id, "CBasePlayer.pl.deadflag")):
				selectPlayer(choice=(id, 'raise'))
	elif choice == 3:
		for id in es.getUseridList():
			if int(es.getplayerprop(id, "CBasePlayer.pl.deadflag")):
				selectPlayer(choice=(id, 'zombie'))
	elif choice == 2:
		pmenu = popuplib.easymenu('pmenu', None, selectPlayer)
		pmenu.settitle('Choose a player to raise as a zombie:')
		for id in es.getUseridList():
			if int(es.getplayerprop(id, "CBasePlayer.pl.deadflag")):
				pmenu.addoption((id, 'raise'), es.getplayername(id))
		pmenu.send(userid)
	elif choice == 1:
		pmenu = popuplib.easymenu('pmenu', None, selectPlayer)
		pmenu.settitle('Choose a player to respawn:')
		for id in es.getUseridList():
			if int(es.getplayerprop(id, "CBasePlayer.pl.deadflag")):
				pmenu.addoption((id, 'zombie'), es.getplayername(id))
		pmenu.send(userid)
Zombies = []
def selectPlayer(userid=None, choice=None, popupid=None):
	#es.msg('Choice[1] = %s'%choice[1])
	if choice[1] == 'zombie':
	#	es.msg('Adding a %s to the zombie list.'%es.getplayername(choice[0]))
		global Zombies
		Zombies.append(int(choice[0]))
	#es.msg(Zombies)
	es.msg('#multi','#green[XA Zombies] #lightgreen%s #defaulthas been raised from the dead!'%es.getplayername(choice[0]))
	es.server.queuecmd('est_spawn %s 1'%choice[0])
	if int(main.setting.getVariable('Zombie_Mod')):
		es.server.queuecmd('zombie_player  #%s'%choice[0])
	DL = Player(choice[0]).Location()
	if DL[0] or DL[1] or DL[2]:
		es.server.queuecmd('es_xsetpos %s %s %s %s'%(choice[0], DL[0], DL[1], DL[2]))
def player_spawn(ev):
	userid = int(ev['userid'])
	if userid in Zombies and not int(main.setting.getVariable('Zombie_Mod')):
		#es.msg('%s is a zombie'%ev['es_username'])
		es.setplayerprop(userid, "CBasePlayer.m_iHealth", float(es.ServerVar('XA_Zombie_Health')))
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", float(es.ServerVar('XA_Zombie_Speed')))
		es.server.queuecmd('est_setplayercolor %s 0 0 0 255 1'%userid)
def item_pickup(ev):
	userid = int(ev['userid'])
	if userid in Zombies and not int(main.setting.getVariable('Zombie_Mod')):
		if ev['item'] not in ['knife','c4']:
			es.server.queuecmd('est_stripplayer %s 1'%userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%userid)
def player_death(ev):
	Player(ev['userid']).Death()
	if int(ev['userid']) in Zombies:
		Zombies.remove(int(ev['userid']))
Players = {}
class Player:
	def __init__(self, userid):
		self.userid = int(userid)
		if not Players.has_key(self.userid):
			Players[self.userid] = {}
			Players[self.userid]['DL'] = (0,0,0)
		self.key = Players[self.userid]
	def Death(self):
		self.key['DL'] = es.getplayerlocation(self.userid)
	def Location(self):
		return self.key['DL']
